"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
if (typeof (Buffer) == 'function') {
    exports.ArrayType = Buffer;
    exports.encodeArray = function (text) { return new Buffer(text); };
    exports.decodeArray = function (data, start, end) { return data.toString('utf-8', start, end); };
    exports.concatArray = Buffer.concat;
}
else if (typeof (TextEncoder) == 'function') {
    exports.ArrayType = Uint8Array;
    var encoder_1 = new TextEncoder('utf-8');
    exports.encodeArray = function (text) { return encoder_1.encode(name); };
    exports.decodeArray = function (data, start, end) { return encoder_1.decode((start || end || end === 0) ? data.slice(start, end) : data); };
    exports.concatArray = function (list, len) {
        var buf = new Uint8Array(len);
        var offset = 0;
        for (var _i = 0, list_1 = list; _i < list_1.length; _i++) {
            var part = list_1[_i];
            buf.set(part, offset);
            offset += part.length;
        }
        return (buf);
    };
}
