import { ArrayType } from './Buffer';
export interface Hasher32 {
    append(data: string | ArrayType): number;
}
/** 32-bit Cyclic Redundancy Check. */
export declare class CRC32 {
    poly: number;
    /** @param poly Reversed generator polynomial, default edb88320 (Ethernet, GZIP, PNG).
      * Other good choices are 82f63b78 (Castagnoli) used in Btrfs and eb31d82e (Koopman). */
    constructor(poly?: number);
    create(): Hasher32;
    tbl: number[];
}
