"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Namespace = /** @class */ (function () {
    /** @param uri Unique identifier for the namespace, should be a valid URI.
      * @param defaultPrefix Default xmlns prefix for serializing to XML. */
    function Namespace(defaultPrefix, uri, id, isSpecial) {
        if (isSpecial === void 0) { isSpecial = false; }
        this.defaultPrefix = defaultPrefix;
        this.uri = uri;
        this.isSpecial = isSpecial;
        this.elementNameList = [];
        this.attributeNameList = [];
        this.schemaLocationList = [];
        this.id = id || Namespace.idLast++;
    }
    Namespace.prototype.addElement = function (name) { this.elementNameList.push(name); };
    Namespace.prototype.addAttribute = function (name) { this.attributeNameList.push(name); };
    Namespace.prototype.addLocation = function (url) { this.schemaLocationList.push(url); };
    Namespace.idLast = 0;
    Namespace.unknown = new Namespace('', '', 0, true);
    Namespace.processing = new Namespace('?', '?', 0, true);
    Namespace.xml1998 = new Namespace('xml', 'http://www.w3.org/XML/1998/namespace');
    return Namespace;
}());
exports.Namespace = Namespace;
Namespace.processing.addElement('xml');
