import { ParserConfig, ParserOptions } from '../parser/ParserConfig';
import { Parser } from '../parser/Parser';
import { SimpleSchemaSpecTbl } from '../schema/SimpleSchema';
import { RuleSet } from './RuleSet';
import { ComplexType } from '../schema/ComplexType';
import { Element, ElementConstructor } from '../schema/Element';
import { ElementToken } from '../parser/Token';
export declare class Builder {
    constructor(parserConfig: ParserConfig, schemaSpec: SimpleSchemaSpecTbl);
    getUnknownProto(token: ElementToken): ElementConstructor<Element>;
    build(parser: Parser, nsUri: string, cb: any): void;
    options: ParserOptions;
    ruleSetTbl: {
        [uri: string]: RuleSet;
    };
    unknownType: ComplexType;
}
