import { SimpleSchema } from '../schema/SimpleSchema';
import { ComplexType } from '../schema/ComplexType';
import { MemberSpec } from '../schema/Member';
import { ElementMeta, ElementConstructor } from '../schema/Element';
export declare class Rule {
    addElement(member: RuleMember): void;
    addAttribute(member: RuleMember): void;
    elements: {
        [id: number]: RuleMember;
    };
    attributes: {
        [id: number]: RuleMember;
    };
    static string: Rule;
    XMLType: ElementConstructor;
}
export declare class RuleMember {
    rule: Rule;
    spec: MemberSpec;
    constructor(rule: Rule, spec: MemberSpec);
    id: number;
    min: number;
    max: number;
}
export interface RuleStack {
    meta?: ElementMeta;
    rule?: Rule;
    parent?: RuleStack;
}
export declare class RuleSet {
    schema: SimpleSchema;
    createRule(type: ComplexType, meta?: ElementMeta, parent?: RuleStack): Rule;
    constructor(schema: SimpleSchema);
    rootRule: Rule;
}
