"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Namespace_1 = require("../Namespace");
var Buffer_1 = require("../Buffer");
var Token_1 = require("./Token");
var InternalToken = /** @class */ (function () {
    function InternalToken(id, kind, name, ns) {
        this.id = id;
        this.name = name;
        this.ns = ns;
        this.buf = Buffer_1.encodeArray(name);
        var nsBase = ns ? ns.base : Namespace_1.Namespace.unknown;
        switch (kind) {
            case 9 /* element */:
                this.open = new Token_1.OpenToken(name, nsBase, id);
                this.close = this.open.close;
                this.emitted = this.open.emitted;
                this.tokenList = [
                    this.open,
                    this.close,
                    this.emitted,
                    null
                ];
                break;
            case 10 /* attribute */:
                this.string = new Token_1.StringToken(name, nsBase, id);
                this.tokenList = [
                    null,
                    null,
                    null,
                    this.string
                ];
                break;
            default:
                break;
        }
    }
    // TODO: Should be an empty string instead.
    InternalToken.empty = new InternalToken(0, 9 /* element */, '\0');
    return InternalToken;
}());
exports.InternalToken = InternalToken;
