import { OpenToken, AttributeToken } from './Token';
import { ParserConfig } from './ParserConfig';
export interface TokenElement extends OpenToken {
    new (): TokenElement;
}
export declare function defineElement(): TokenElement;
export declare function defineAttribute(): AttributeToken;
export interface XModule {
    [name: string]: string | TokenElement | AttributeToken;
}
export interface XModuleTable {
    [prefix: string]: XModule;
}
export interface XMLElementNode<Attributes> extends Array<string | Attributes | XMLNode[]> {
    0: any;
    1: Attributes;
    2: XMLNode[];
}
export declare class XMLArgumentNode {
    name: string;
    constructor(name: string);
}
export declare type XMLNode = XMLElementNode<any> | XMLArgumentNode | string | number | boolean | undefined;
export declare function jsxElement<Attributes>(kind: string, attr: Attributes, ...children: XMLNode[]): XMLElementNode<Attributes>;
export declare function jsxExpand(config: ParserConfig, node: XMLNode, output: (any[] | XMLArgumentNode)[], part?: any[]): any;
export declare function jsxCompile(config: ParserConfig, generate: (...args: any[]) => XMLElementNode<any>): any;
