"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Token_1 = require("./Token");
function defineElement() {
    return true;
}
exports.defineElement = defineElement;
function defineAttribute() {
    return false;
}
exports.defineAttribute = defineAttribute;
var XMLArgumentNode = /** @class */ (function () {
    function XMLArgumentNode(name) {
        this.name = name;
    }
    return XMLArgumentNode;
}());
exports.XMLArgumentNode = XMLArgumentNode;
function jsxElement() { return (Array.prototype.slice.apply(arguments)); }
exports.jsxElement = jsxElement;
function jsxExpand(config, node, output, part) {
    if (part === void 0) { part = output[0]; }
    if (typeof (node) != 'object') {
        part.push(node);
    }
    else if (node instanceof Array) {
        var element = node[0];
        var attributes = node[1] || {};
        // If the first element is not a token or the second element is,
        // then the node is already expanded!
        // An attribute, emitted or close token always follows
        // an open token in expanded nodes.
        if (!(element instanceof Token_1.OpenToken) || attributes instanceof Token_1.Token) {
            // Flatten and output the already expanded node.
            return (element instanceof Array ? Array.prototype.concat.apply([], node) : node);
        }
        part.push(element);
        for (var _i = 0, _a = Object.keys(attributes); _i < _a.length; _i++) {
            var name_1 = _a[_i];
            var attr = attributes[name_1];
            part.push(config.getAttributeTokens(element.ns, name_1)[3 /* string */]);
            if (attr instanceof XMLArgumentNode) {
                output.push(attr);
                part = [];
                output.push(part);
            }
            else {
                part.push(attr);
            }
        }
        if (node.length > 2) {
            part.push(element.emitted);
            for (var num = 2; num < node.length; ++num) {
                part = jsxExpand(config, node[num], output, part);
            }
        }
        part.push(element.close);
    }
    else if (node instanceof XMLArgumentNode) {
        output.push(node);
        part = [];
        output.push(part);
    }
    return (part);
}
exports.jsxExpand = jsxExpand;
function jsxCompile(config, generate) {
    var template = generate(function (name) { return new XMLArgumentNode(name); });
    // console.log(require('util').inspect(template, { depth: null }));
    var parts = [[]];
    jsxExpand(config, template, parts);
    var rest = parts.slice(1);
    // Compile a function that expands and interpolates arguments into the template.
    return (eval(
    // The function returns the first part of expanded output...
    '(function compiled(spec) {return(parts[0]' +
        // ...with other parts appended, if any.
        (!rest.length ? '' :
            '.concat(' + rest.map(function (part, pos) { return (part instanceof XMLArgumentNode ? (
            // Expand parts representing arguments.
            'jsxExpand(config,spec.' + part.name + '||"",[[]])') : (
            // Output already expanded parts as-is.
            'rest[' + pos + ']')); }).join(',') + ')') +
        ');})'));
}
exports.jsxCompile = jsxCompile;
