import { AttributeSpec } from './Attribute';
import { AttributeGroup } from './AttributeGroup';
import { SimpleElementSpec, ElementSpec, ElementBase } from './Element';
export interface ElementTypeConstructor<ElementClass extends ElementBase = ElementBase> {
    new (): ElementClass;
}
/** Definition of a type containing other elements and attributes. Only applicable to elements. */
export declare class ComplexType {
    addAttribute(spec: AttributeSpec): void;
    addAll(spec: SimpleElementSpec | ElementSpec): void;
    createProto<ElementClass = ElementBase>(): ElementTypeConstructor<ElementClass>;
    base?: ComplexType;
    XMLType: ElementTypeConstructor;
    attributes?: AttributeGroup;
    elements?: ElementSpec;
}
