import { MemberToken } from '../parser/Token';
import { ComplexType } from './ComplexType';
/** SimpleType equivalent JavaScript data types. */
export declare type SimpleValue = string | number | boolean;
/** Configuration for elements and attributes as type members. */
export declare class MemberSpec {
    min: number;
    max: number;
    constructor(min?: number, max?: number);
    meta?: MemberMeta;
}
/** Definition of a type with only text content.
  * Applicable to both elements and attributes. */
export declare class SimpleType {
    base?: SimpleType;
}
export declare class MemberMeta {
    token: MemberToken;
    /** @param token Token with element or attribute name and namespace.
      * A single token may have different types depending on its parent. */
    constructor(token: MemberToken);
    exists: boolean;
    type: SimpleType | ComplexType;
}
