import { ParserConfig } from '../parser/ParserConfig';
import { Namespace } from '../Namespace';
import { ComplexType } from './ComplexType';
import { SimpleType } from './Member';
export declare type SimpleMemberSpec = string | {
    [memberName: string]: string;
};
export declare type SimpleSchemaSpec = {
    [typeName: string]: SimpleMemberSpec[];
};
export declare type SimpleSchemaSpecTbl = {
    [prefix: string]: [string, string, SimpleSchemaSpec];
};
export declare class SimpleSchema {
    private parserConfig;
    ns: Namespace;
    constructor(parserConfig: ParserConfig, ns: Namespace, spec: SimpleSchemaSpec, root?: SimpleMemberSpec[]);
    defineType(spec: SimpleMemberSpec[], type?: ComplexType): ComplexType;
    typeTbl: {
        [typeName: string]: SimpleType | ComplexType;
    };
    document: ComplexType;
}
