/// <reference types="node" />
import { ParserNamespace } from '../parser/ParserNamespace';
import { TokenSpace } from './TokenSpace';
import { InternalToken } from '../parser/InternalToken';
export declare class TokenSet {
    private space;
    constructor(space: TokenSpace, parent?: TokenSet);
    private makeIndependent();
    createToken(name: string, ns?: ParserNamespace): InternalToken;
    addToken(token: InternalToken): void;
    encodeTrie(): Uint8Array | Buffer;
    /** If false, object is a clone sharing data with a parent object. */
    private isIndependent;
    private tbl;
    private trie;
    dirty: boolean;
}
