"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var InternalToken_1 = require("../parser/InternalToken");
/** Allocates IDs for distinguishing between tokens of the same type. */
var TokenSpace = /** @class */ (function () {
    function TokenSpace(kind, parent) {
        this.kind = kind;
        this.isIndependent = !parent;
        if (parent) {
            this.idLast = parent.idLast;
            this.list = parent.list;
        }
        else {
            this.idLast = 0;
            this.list = [];
        }
    }
    TokenSpace.prototype.makeIndependent = function () {
        if (this.isIndependent)
            return;
        this.isIndependent = true;
        this.list = this.list.slice(0);
    };
    TokenSpace.prototype.createToken = function (name, ns) {
        if (!this.isIndependent)
            this.makeIndependent();
        var token = new InternalToken_1.InternalToken(++this.idLast, this.kind, name, ns);
        this.list[token.id] = token;
        return (token);
    };
    return TokenSpace;
}());
exports.TokenSpace = TokenSpace;
