/// <reference types="node" />
import * as stream from 'stream';
import { TokenChunk } from '../parser/TokenChunk';
import { ParserConfig } from '../parser/ParserConfig';
export declare class JsonWriter extends stream.Transform {
    private config;
    private data;
    /** @param config Parser config passed to any custom serializers.
      * @param data Arbitrary data passed to any custom serializers. */
    constructor(config?: ParserConfig | undefined, data?: any);
    transform(chunk: TokenChunk): string[];
    _transform(chunk: TokenChunk | null, enc: string, flush: (err: any, chunk: string) => void): void;
    _flush(flush: (err: any, chunk: string) => void): void;
    private state;
    private depth;
    private indent;
    private nsElement;
}
