/// <reference types="node" />
import * as stream from 'stream';
import { Namespace } from '../Namespace';
import { TokenChunk } from '../parser/TokenChunk';
import { TokenBuffer } from '../parser/Token';
import { ParserConfig } from '../parser/ParserConfig';
export declare const enum Indent {
    MIN_DEPTH = 1,
    MAX_DEPTH = 256,
}
export declare const enum State {
    ELEMENT = 0,
    PROCESSING = 1,
    TEXT = 2,
    AFTER_TEXT = 3,
    COMMENT = 4,
}
export declare const indentPattern: string;
export declare class Writer extends stream.Transform {
    private config;
    private data;
    /** @param config Parser config passed to any custom serializers.
      * @param data Arbitrary data passed to any custom serializers. */
    constructor(config?: ParserConfig | undefined, data?: any);
    transform(chunk: TokenChunk | TokenBuffer | string, partList: string[]): string[];
    _transform(chunk: TokenChunk | TokenBuffer | null, enc: string, flush: (err: any, chunk: string) => void): void;
    _flush(flush: (err: any, chunk: string) => void): void;
    copyPrefixes(namespaceList: (Namespace | undefined)[]): void;
    private chunkCount;
    private state;
    private depth;
    private indent;
    private nsElement;
    private prefixList;
    private prefixTbl;
    private xmlnsDefinitions;
}
