// TODO: cdata start/end (disables entity parsing on JS side)
export const enum CodeType {
	OPEN_ELEMENT_ID = 0,
	CLOSE_ELEMENT_ID,
	ATTRIBUTE_ID,
	PREFIX_ID,
	XMLNS_ID,
	URI_ID,

	ELEMENT_EMITTED,
	CLOSED_ELEMENT_EMITTED,

	NAMESPACE_ID,

	VALUE_START_OFFSET,
	VALUE_END_OFFSET,

	TEXT_START_OFFSET,
	TEXT_END_OFFSET,

	COMMENT_START_OFFSET,
	COMMENT_END_OFFSET,

	// Unrecognized element name.
	UNKNOWN_START_OFFSET,

	// The order of these must match OPEN_ELEMENT_ID, CLOSE_ELEMENT_ID...
	UNKNOWN_OPEN_ELEMENT_END_OFFSET,
	UNKNOWN_CLOSE_ELEMENT_END_OFFSET,
	UNKNOWN_ATTRIBUTE_END_OFFSET,
	UNKNOWN_PREFIX_END_OFFSET,
	UNKNOWN_XMLNS_END_OFFSET,
	UNKNOWN_URI_END_OFFSET,

	// Recognized part from an unrecognized name.
	PARTIAL_ELEMENT_ID,
	PARTIAL_ATTRIBUTE_ID,
	PARTIAL_PREFIX_ID,
	PARTIAL_URI_ID,
	PARTIAL_LEN
};
